
#include <WiFi.h>
#include <FirebaseESP32.h>
#include "time.h"

#define DATA_PATH "/live/data/waterLevel"

bool taken = false;
#define NOTE_C4  261    // Define the frequency for note C4 (Do)
#define NOTE_D4  294    // Define the frequency for note D4 (Re)
#define NOTE_E4  330    // Define the frequency for note E4 (Mi)

#define SPEAKER_PIN  D2   // Define the pin to which the speaker is connected

#define rxpin D0 // receive pin (D0 on XIAO ESP32-C3)
#define txpin D8 // transmit pin (D8 on XIAO ESP32-C3)
#define settle 100 // settle time
#define samples 100 // number of samples to accumulate
int32_t waterLevel = 0;
int32_t difference = 0;


//Wifi Confifg
#define WIFI_SSID "FabGuest"       // your wifi SSID
#define WIFI_PASSWORD "4fabGUEST"  // your Wiif Password

//Firebase config
#define FIREBASE_HOST "https://aqua-buddy-3d5cb-default-rtdb.firebaseio.com/"  // firebase realtimeDB api url https://project-name.firebaseio.com/
#define FIREBASE_AUTH "AIzaSyCoLwSZiBMunNANLwR6ctUlQLtbasnj9OM"                        // API key


FirebaseData fbdo;
FirebaseJson json;
FirebaseJson json2;


// NTP Server config
// const char *ntpServer = "pool.ntp.org";
// const long gmtOffset_sec = 5 * 3600 + 30 * 60;  // UTC+5:30
// const int daylightOffset_sec = 0;               // India does not observe daylight saving time

// int timestamp;



void setup() {

    Serial.begin(115200);

  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi...");
  }
  Serial.println("Connected to WiFi");
  
    // Initialize Firebase
  Firebase.begin(FIREBASE_HOST, FIREBASE_AUTH);


  // configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);
  // timestamp = printLocalTime(1);
     pinMode(txpin, OUTPUT); // set transmit pin to output
   analogReadResolution(12); // set ADC resolution to 12 bits (ESP32)
     pinMode(SPEAKER_PIN, OUTPUT);  // Set the speaker pin as an output
    pinMode(D4, OUTPUT);

  
  }

void loop() {

  int senserData = waterData();

 if (senserData>=100){senserData = 100;}

  if (Firebase.setInt(fbdo, DATA_PATH, senserData)) {

  } else {
    Serial.println("Failed to set data");
    Serial.println("Reason: " + fbdo.errorReason());
  }

   if (Firebase.setInt(fbdo, "/live/data/value", difference)) {

  } else {
    Serial.println("Failed to set data");
    Serial.println("Reason: " + fbdo.errorReason());
  }

  
  delay(500);
 digitalWrite(D4, HIGH);  // turn the LED on (HIGH is the voltage level)
 delay(100);
digitalWrite(D4, LOW);  // turn the LED on (HIGH is the voltage level)


}


int waterData(){
     int32_t up, down;
   up = down = 0;
   noInterrupts(); // disable interrupts while measuring
   for (int i = 0; i < samples; ++i) {
      digitalWrite(txpin, HIGH); // charge up
      up += analogRead(rxpin); // read
      delayMicroseconds(settle); // settle
      digitalWrite(txpin, LOW); // charge down
      down += analogRead(rxpin); // read
      delayMicroseconds(settle); // settle
   }
   interrupts(); // enable interrupts after measuring
   difference = up - down;
  //  Serial.print(difference);
// waterLevel = map(difference, 60840, 239645, 0, 100);
waterLevel = map(difference, 63083, 147481, 0, 100);




  //  Serial.print("\t");
   Serial.print(waterLevel);
  //  Serial.println("%");
  //  Serial.flush(); // finish communicating before measuring

 return waterLevel;
}
